/*
 *  Copyright (c) 2008-2012 Sonatype, Inc. All rights reserved.
 *
 *  This program is licensed to you under the Apache License Version 2.0,
 *  and you may not use this file except in compliance with the Apache License Version 2.0.
 *  You may obtain a copy of the Apache License Version 2.0 at http://www.apache.org/licenses/LICENSE-2.0.
 *
 *  Unless required by applicable law or agreed to in writing,
 *  software distributed under the Apache License Version 2.0 is distributed on an
 *  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the Apache License Version 2.0 for the specific language governing permissions and limitations there under.
 */
package org.sonatype.jira;

/**
 * Defines supported XMLRPC JIRA calls. Modeled after JIRA 4.1.2
 */
@SuppressWarnings( "rawtypes" )
public interface JiraXmlRpc
{
    boolean addComment( java.lang.String token, java.lang.String issueKey, java.lang.String comment );

    java.util.Hashtable createIssue( java.lang.String token, java.util.Hashtable rIssueStruct );

    java.util.Vector getComments( java.lang.String token, java.lang.String issueKey );

    java.util.Vector getComponents( java.lang.String token, java.lang.String projectKey );

    java.util.Vector getFavouriteFilters( java.lang.String token );

    java.util.Hashtable getIssue( java.lang.String token, java.lang.String issueKey );

    java.util.Vector getIssuesFromFilter( java.lang.String token, java.lang.String filterId );

    java.util.Vector getIssuesFromTextSearch( java.lang.String token, java.lang.String searchTerms );

    java.util.Vector getIssuesFromTextSearchWithProject( java.lang.String token, java.util.Vector projectKeys,
                                                         java.lang.String searchTerms, int maxNumResults );

    java.util.Vector getIssueTypes( java.lang.String token );

    java.util.Vector getIssueTypesForProject( java.lang.String token, java.lang.String projectId );

    java.util.Vector getPriorities( java.lang.String token );

    java.util.Vector getProjectsNoSchemes( java.lang.String token );

    java.util.Vector getResolutions( java.lang.String token );

    @Deprecated
    java.util.Vector getSavedFilters( java.lang.String token );

    java.util.Hashtable getServerInfo( java.lang.String token );

    java.util.Vector getStatuses( java.lang.String token );

    java.util.Vector getSubTaskIssueTypes( java.lang.String token );

    java.util.Vector getSubTaskIssueTypesForProject( java.lang.String token, java.lang.String projectId );

    java.util.Hashtable getUser( java.lang.String token, java.lang.String username );

    java.util.Vector getVersions( java.lang.String token, java.lang.String projectKey );

    java.lang.String login( java.lang.String username, java.lang.String password );

    Boolean logout( java.lang.String token );

    java.util.Hashtable updateIssue( java.lang.String token, java.lang.String issueKey, java.util.Hashtable fieldValues );

}
